Subject: bug#10519: guile and (mini-)gmp

From: [email-masked] (Ludovic Courtès)
Date: Sun, 12 Aug 2012 00:48:21 +0200

[email-masked] (Niels Möller) skribis:

> [email-masked] (Ludovic Courtès) writes:
>
>> For me/us, the best workflow would be to have a Gnulib module.  That
>> way, whenever GMP developers fix a bug in mini-gmp, we automatically get
>> the fix when running “gnulib-tool --update”.
>
> I guess you can do whatever you want in gnulib. But it should be made
> very clear that the gmp repo is the "official" version. Some gmp
> developers would be upset if a mini-gmp version in gnulib starts to
> diverge.

Yes, sure.  There are cases where Gnulib contains copies of code
actually maintained elsewhere, such as in glibc.  I’ll check with the
Gnulib folks whether/how such an arrangement could be made.

>> What about the maintenance overhead for GMP developers?  I mean, of
>> those 5000 lines, most are copied from GMP, right?
>
> Not really. Some of that code is of course copied from various other gmp
> files, but a lot of it is written from scratch, giving priority to
> simplicity over performance.

OK.

>> So, bugs found in GMP may have to be fixed in mini-GMP too, for
>> instance.
>
> That's possible, but I don't think it's likely to be a big problem. I'd
> expect the typical bug in mini-gmp to be in the code which is *not*
> copied from other GMP files. And I'd expect the typical bug in gmp to be
> in complex algorithms or assembly code, which doesn't have any
> counterpart in mini-gmp.

Right.

> mini-gmp does have a reasonable testsuite, even if it's not as thorough
> as the main gmp testsuite. And mini-gmp is used in a normal gmp build
> (via bootstrap.c), for computing various tables used by the main gmp
> code. So the gmp project itself also depends on mini-gmp.

OK, good to know.  ;-)

Thanks!

Ludo’.